'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ramda = require('ramda');

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)(_actions.creators, dispatch)
  };
};

var propTypes = {
  // internal props
  actions: _propTypes2.default.shape({
    keyDown: _propTypes2.default.func.isRequired,
    keyUp: _propTypes2.default.func.isRequired,
    setValue: _propTypes2.default.func.isRequired
  }),

  // user-facing props
  onInputChange: _propTypes2.default.func,
  state: _propTypes2.default.shape({
    value: _propTypes2.default.string
  }).isRequired
};

var extractChildProps = (0, _ramda.omit)((0, _ramda.keys)(propTypes));

var noop = function noop() {};

var defaultProps = {
  onInputChange: noop
};

var KeystrokeHistory = (_dec = (0, _reactRedux.connect)(null, mapDispatchToProps), _dec(_class = (_temp2 = _class2 = function (_React$Component) {
  _inherits(KeystrokeHistory, _React$Component);

  function KeystrokeHistory() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, KeystrokeHistory);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = KeystrokeHistory.__proto__ || Object.getPrototypeOf(KeystrokeHistory)).call.apply(_ref, [this].concat(args))), _this), _this.onKeyDown = function (e) {
      var metaKey = e.metaKey,
          repeat = e.repeat;

      _this.props.actions.keyDown(e.key, { metaKey: metaKey, repeat: repeat });
    }, _this.onKeyUp = function (e) {
      _this.props.actions.keyUp(e.key);
    }, _this.onChange = function (e) {
      _this.props.actions.setValue(e.target.value);
      _this.props.onInputChange(e);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(KeystrokeHistory, [{
    key: 'render',
    value: function render() {
      var value = this.props.state.value;

      var childProps = extractChildProps(this.props);

      return _react2.default.createElement('input', _extends({
        type: 'text',
        value: value,
        onKeyDown: this.onKeyDown,
        onKeyUp: this.onKeyUp,
        onChange: this.onChange
      }, childProps));
    }
  }]);

  return KeystrokeHistory;
}(_react2.default.Component), _class2.propTypes = propTypes, _class2.defaultProps = defaultProps, _temp2)) || _class);
exports.default = KeystrokeHistory;