'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.creators = exports.TYPES = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _keycode = require('keycode');

var _keycode2 = _interopRequireDefault(_keycode);

var _ramda = require('ramda');

var _graftssReduxUtils = require('graftss-redux-utils');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TYPES = exports.TYPES = {
  CLEAR_HISTORY: 'KEYSTROKE_HISTORY_CLEAR_HISTORY',
  KEY_DOWN: 'KEYSTROKE_HISTORY_KEY_DOWN',
  KEY_UP: 'KEYSTROKE_HISTORY_KEY_UP',
  SET_VALUE: 'KEYSTROKE_HISTORY_SET_VALUE'
};

var keyToKeycodeData = function keyToKeycodeData(key, context) {
  return { keycode: (0, _keycode2.default)(key), context: context };
};
var withTimestamp = (0, _graftssReduxUtils.withMeta)(function () {
  return { timestamp: (0, _utils.getTime)() };
});

var baseInputCreators = {
  keyDown: (0, _graftssReduxUtils.generateCreator)(TYPES.KEY_DOWN, keyToKeycodeData),
  keyUp: (0, _graftssReduxUtils.generateCreator)(TYPES.KEY_UP, keyToKeycodeData)
};

var baseCreators = {
  clearHistory: (0, _graftssReduxUtils.constantCreator)(TYPES.CLEAR_HISTORY),

  clearValue: function clearValue() {
    return { type: TYPES.SET_VALUE, payload: { value: '' } };
  },

  setValue: (0, _graftssReduxUtils.argListCreator)(TYPES.SET_VALUE, ['value'])
};

var creators = exports.creators = _extends({}, baseCreators, (0, _ramda.map)(withTimestamp, baseInputCreators));