'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _switchReducer;

var _ramda = require('ramda');

var _graftssReduxUtils = require('graftss-redux-utils');

var _actions = require('./actions');

var _state = require('./state');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var newHistoryEntry = function newHistoryEntry(keyDownAction) {
  return {
    keycode: keyDownAction.payload.keycode,
    down: keyDownAction.meta.timestamp
  };
};

var shouldIgnoreKeydown = function shouldIgnoreKeydown(keyDownAction) {
  var _keyDownAction$payloa = keyDownAction.payload,
      keycode = _keyDownAction$payloa.keycode,
      _keyDownAction$payloa2 = _keyDownAction$payloa.context,
      context = _keyDownAction$payloa2 === undefined ? {} : _keyDownAction$payloa2;

  // don't count a keydown event when meta is being held, because
  // (among other reasons) there won't be a corresponding keyup.

  if (context.metaKey) return true;

  // similarly, don't include keydowns caused by a repeat.
  if (context.repeat) return true;

  // don't count unrecognized keys, i.e. those without a keycode
  if (keycode === undefined) return true;

  return false;
};

var keyDown = _state.state.overWith([_state.state.view.actionKeyHistoryIndex, _state.state.view.history], function (index, history, action) {
  if (shouldIgnoreKeydown(action)) return {};

  var adjustedHistory = index === undefined ? history : (0, _ramda.adjust)((0, _ramda.merge)({ unresolved: true }), index, history);

  return {
    history: [].concat(_toConsumableArray(adjustedHistory), [newHistoryEntry(action)]),
    actionKeyHistoryIndex: history.length
  };
});

var keyUpEntryData = function keyUpEntryData(keyUpAction) {
  return {
    up: keyUpAction.meta.timestamp
  };
};

var keyUp = _state.state.overWith([_state.state.view.actionKeyHistoryIndex, _state.state.view.history], function (index, history, action) {
  if (index === undefined) return {};

  return {
    actionKeyHistoryIndex: undefined,
    history: (0, _ramda.adjust)((0, _ramda.merge)(keyUpEntryData(action)), index, history)
  };
});

var setValue = _state.state.over.value((0, _graftssReduxUtils.fromPayload)('value'));

var clearHistory = _state.state.set.history([]);

exports.default = (0, _graftssReduxUtils.switchReducer)(_state.initialState, (_switchReducer = {}, _defineProperty(_switchReducer, _actions.TYPES.CLEAR_HISTORY, clearHistory), _defineProperty(_switchReducer, _actions.TYPES.KEY_DOWN, keyDown), _defineProperty(_switchReducer, _actions.TYPES.KEY_UP, keyUp), _defineProperty(_switchReducer, _actions.TYPES.SET_VALUE, setValue), _switchReducer));