const { join } = require('path');

const exampleDir = join(__dirname, 'example');

const paths = {};
paths.src = join(exampleDir, 'src');
paths.build = join(exampleDir, 'build');
paths.public = join(exampleDir, 'src');
paths.entry = join(paths.src, 'index.jsx');

module.exports = {
  resolve: {
    extensions: ['.js', '.jsx'],
  },

  module: {
    loaders: [
      {
        test: /\.jsx?$/,
        loader: 'babel-loader',
        exclude: /node_modules/,
      },
    ],
  },

  entry: {
    example: paths.entry,
  },

  output: {
    path: paths.build,
    filename: '[name].bundle.js',
    publicPath: '/build',
  },

  devServer: {
    contentBase: paths.public,
  },
};
